unit UFrmPadrao;

interface

uses  
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, DBCtrls, StdCtrls, Buttons, ComCtrls, Mask, Grids, DBGrids, Db,
  ToolWin;

type
  TOperState=(opNone,opNewForInsert,opDelete,opSave,opDiscard,opCancel,opNewForSearch,opSearch);
  TRecordState=(rdInactive,rdNewForSearch,rdNewForInsert,rdBrowse,rdEdit);
  TFrmPadrao = class(TForm)
    PanelMsg: TPanel;
    stbMsg: TStatusBar;
    Dts1: TDataSource;
    Panel1: TPanel;
    DBNavigator1: TDBNavigator;
    BtnAjuda: TSpeedButton;
    BtnAppend: TSpeedButton;
    BtnDelete: TSpeedButton;
    BtnSave: TSpeedButton;
    BtnDiscard: TSpeedButton;
    BtnImprimir: TSpeedButton;
    BtnVisualizar: TSpeedButton;
    BtnFechar: TSpeedButton;
    btnSearch: TSpeedButton;
    BtnNewForSearch: TSpeedButton;
    PGCManutencao: TPageControl;
    TBSCadastro: TTabSheet;
    Panel4: TPanel;
    TBSConsulta: TTabSheet;
    DBGrid1: TDBGrid;
    procedure BtnFecharClick(Sender: TObject);
    procedure Dts1StateChange(Sender: TObject);
    procedure BtnSaveClick(Sender: TObject);
    procedure BtnDiscardClick(Sender: TObject);
    procedure BtnDeleteClick(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure BtnAppendClick(Sender: TObject);
    procedure DBGrid1DblClick(Sender: TObject);
    procedure PGCManutencaoChanging(Sender: TObject;
      var AllowChange: Boolean);
    procedure BtnImprimirClick(Sender: TObject);
    procedure BtnAjudaClick(Sender: TObject);
    procedure BtnVisualizarClick(Sender: TObject);
    procedure FormDeactivate(Sender: TObject);
    procedure Dts1UpdateData(Sender: TObject);
    procedure BtnNewForSearchClick(Sender: TObject);
    procedure btnSearchClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure DBGrid1TitleClick(Column: TColumn);
  private
    { Private declarations }
  public
    { Public declarations }
    Usuario: String;
    CmdSelect: String;
    CmdOrderBy: String;
    CmdSelectNull: String;
    OperState: TOperState;
    RecordState: TRecordState;
    procedure Save;
    procedure NewForInsert;
    procedure Delete;
    procedure Discard;
    procedure NewForSearch;
    procedure Search;
    procedure CreateFrmRel;
    procedure SetRecordState(Value: TRecordState);
    function BuildQBE: String;
  end;

var
  FrmPadrao: TFrmPadrao;
  sQBE: String;

implementation

uses dbTables, UfrmDuvida;


{$R *.DFM}



procedure TFrmPadrao.BtnFecharClick(Sender: TObject);
begin
  close;
end;

procedure TFrmPadrao.Dts1StateChange(Sender: TObject);
begin
  if Dts1.State = dsEdit then
     SetRecordState(rdEdit);
  if Dts1.Dataset.State = dsBrowse then
     stbMsg.SimpleText := IntToStr(Dts1.Dataset.RecordCount)+' registro(s) selecionado(s)...';
end;


procedure TFrmPadrao.PGCManutencaoChanging(Sender: TObject;
  var AllowChange: Boolean);
begin
  if (Dts1.State = dsInsert) or (Dts1.State = dsEdit) then
    if MessageDlg('Deseja confirmar as alteraes ?',
       mtConfirmation, [mbYes, mbNo], 0) = mrYes then
       Save
    else Discard;
end;

procedure TFrmPadrao.BtnImprimirClick(Sender: TObject);
begin
  CreateFrmRel;
end;

procedure TFrmPadrao.BtnAjudaClick(Sender: TObject);
begin
 if frmDuvida = nil then
    frmDuvida := TfrmDuvida.Create(Application)
  else
     if frmDuvida.WindowState = wsMinimized then
         frmDuvida.WindowState := wsNormal;
  frmDuvida.Show;
  frmDuvida := nil;
end;

procedure TFrmPadrao.BtnVisualizarClick(Sender: TObject);
begin
  CreateFrmRel;
end;

procedure TFrmPadrao.FormDeactivate(Sender: TObject);
begin
  if (Dts1.State = dsInsert) or (Dts1.State = dsEdit) then
    if MessageDlg('Deseja confirmar as alteraes ?',
       mtConfirmation, [mbYes, mbNo], 0) = mrYes then
       Dts1.Dataset.post
    else Dts1.Dataset.cancel;
end;

procedure TFrmPadrao.NewForInsert;
var
  OldOperState: TOperState;
begin
  OldOperState := OperState;
  OperState := opNewForInsert;
  try
    if not TBDEDataSet(Dts1.DataSet).Active then
      begin
        TQuery(Dts1.DataSet).SQL.Text := CmdSelect + CmdSelectNull;
        TBDEDataSet(Dts1.DataSet).Open;
      end;
    Dts1.Dataset.append;
    SetRecordState(rdNewForInsert);
  finally
    OperState := OldOperState;
  end;
end;

procedure TFrmPadrao.Delete;
var
  OldOperState: TOperState;
begin
  OldOperState:= OperState;
  OperState:=opDelete;
  try
    if MessageDlg('Confirma excluso?',
       mtConfirmation, [mbYes, mbNo], 0) = mrYes then
       begin
         Dts1.Dataset.delete;
         TBDEDataSet(Dts1.Dataset).ApplyUpdates;
         TBDEDataSet(Dts1.Dataset).CommitUpdates;
         stbMsg.SimpleText := IntToStr(Dts1.Dataset.RecordCount)+' registro(s) selecionado(s)...';
         if TBDEDataSet(Dts1.DataSet).IsEmpty then
           begin
             TBDEDataSet(Dts1.Dataset).Close;
             SetRecordState(rdInactive);
           end
         else
           SetRecordState(rdBrowse);
       end;
  finally
    OperState:=OldOperState;
  end;
end;

procedure TFrmPadrao.Save;
var
  OldOperState: TOperState;
begin
  OldOperState:= OperState;
  OperState:=opSave;
  try
    TBDEDataSet(Dts1.Dataset).post ;
    TBDEDataSet(Dts1.Dataset).ApplyUpdates;
    TBDEDataSet(Dts1.Dataset).CommitUpdates;
 //   dtmdb.Dbsisven.Commit ;
    SetRecordState(rdBrowse);
  finally
    OperState:=OldOperState;
  end;
end;

procedure TFrmPadrao.Discard;
var
  OldOperState: TOperState;
begin
  OldOperState:= OperState;
  OperState:=opDiscard;
  try
    if TBDEDataSet(Dts1.Dataset).UpdatesPending then
      begin
        if MessageDlg('Deseja cancelar atualizaes?',
           mtConfirmation, [mbYes, mbNo], 0) = mrYes then
           TBDEDataSet(Dts1.Dataset).CancelUpdates;
      end
    else
      TBDEDataSet(Dts1.Dataset).Cancel;
    if TBDEDataSet(Dts1.DataSet).IsEmpty then
      begin
        TBDEDataSet(Dts1.Dataset).Close;
        SetRecordState(rdInactive);
      end
    else
      SetRecordState(rdBrowse);
  finally
    OperState:=OldOperState;
  end;
end;

procedure TFrmPadrao.Dts1UpdateData(Sender: TObject);
var
  ret: integer;
begin
  if OperState in[opNone,opNewForInsert] then
    begin
      ret := Application.MessageBox('Deseja salvar as alteraes?',
         'Confirmao', MB_YESNOCANCEL + MB_ICONQUESTION );
      case ret of
        idYes: Save;
        idNo: Discard;
        idCancel: Abort;
      end;
    end;
  stbMsg.SimpleText := IntToStr(Dts1.Dataset.RecordCount)+' registro(s) selecionado(s)...';
end;


procedure TFrmPadrao.BtnNewForSearchClick(Sender: TObject);
begin
  NewForSearch;
end;

procedure TFrmPadrao.btnSearchClick(Sender: TObject);
begin
  Search;
end;

procedure TFrmPadrao.FormCreate(Sender: TObject);
begin
  OperState := opNone;
  SetRecordState(rdInactive);
  CmdSelect := TQuery(Dts1.DataSet).SQL.Text;
  CmdOrderBy := 'ORDER BY '+Dts1.DataSet.Fields[0].FieldName ;
  CmdSelectNull := 'WHERE '+Dts1.DataSet.Fields[0].FieldName+' IS NULL';
end;

procedure TFrmPadrao.FormDestroy(Sender: TObject);
begin
  TBDEDataSet(Dts1.DataSet).Close;
  TQuery(Dts1.DataSet).SQL.Text := CmdSelect;
end;

procedure TFrmPadrao.NewForSearch;
var
  OldOperState: TOPerState;
begin
  OldOperState := OperState;
  OperState := opNewForSearch;
  try
    if not TBDEDataSet(Dts1.DataSet).Active then
      begin
        TQuery(Dts1.DataSet).SQL.Text := cmdSelect + cmdSelectNull;
        TBDEDataSet(Dts1.Dataset).Open;
      end;
      TBDEDataSet(Dts1.Dataset).Append;
      SetRecordState(rdNewForSearch);
  finally
     OperState := OldOperState;
  end;
end;

procedure TFrmPadrao.Search;
var
  OldOperState: TOPerState;
begin
  ActiveControl := Nil;
  OldOperState := OperState;
  OperState := opSearch;
  try
    sQBE := BuildQBE;
    TBDEDataSet(Dts1.DataSet).Close;
    TQuery(Dts1.DataSet).SQL.Text := cmdSelect;
    if sQBE <> '' then
       TQuery(Dts1.DataSet).SQL.Text := cmdSelect + ' WHERE ' + sQBE;
    TQuery(Dts1.DataSet).SQL.Text :=
    TQuery(Dts1.DataSet).SQL.Text + cmdOrderBy;
    TBDEDataSet(Dts1.DataSet).Open;
    if TBDEDataSet(Dts1.DataSet).IsEmpty then
       SetRecordState(rdNewForSearch)
    else
       SetRecordState(rdBrowse);
  finally
    OperState := OldOperState;
    stbMsg.SimpleText := IntToStr(Dts1.Dataset.RecordCount)+' registro(s) selecionado(s)...';
  end;
end;

function TfrmPadrao.BuildQBE: String;
var
  sep: string;
  j: integer;
begin
  Sep := '';
  For j:=0 to Dts1.DataSet.FieldCount - 1 do
    if (Dts1.DataSet.Fields[j].AsString <> '') then
      begin
        if Dts1.dataset.fields[j].DataType = ftstring then
           result := format ('%s%s (%s like ''%%%s%s'')', [result, sep,
               Dts1.dataset.fields[j].fieldname,
               Dts1.dataset.fields[j].asstring, '%'])
        else
           result := format ('%s%s (%s = %s)', [result, sep,
               Dts1.dataset.fields[j].fieldname,
               Dts1.dataset.fields[j].asstring]);
        Sep := 'And';
      end;
end;

procedure TFrmPadrao.SetRecordState(Value: TRecordState);
begin
  RecordState:=Value;
  Case RecordState of
    rdInactive:
      begin
        btnNewForSearch.Enabled:=TRUE;
        btnAppend.Enabled:=TRUE;
        btnSearch.Enabled:=FALSE;
        btnSave.Enabled:=FALSE;
        btnDiscard.Enabled:=FALSE;
        btnDelete.Enabled:=FALSE;
        btnImprimir.Enabled:=FALSE;
        btnVisualizar.Enabled:=FALSE;
        btnAjuda.Enabled:=TRUE;
        btnFechar.Enabled:=TRUE;
      end;
    rdNewForSearch:
      begin
        btnNewForSearch.Enabled:=FALSE;
        btnAppend.Enabled:=FALSE;
        btnSearch.Enabled:=TRUE;
        btnSave.Enabled:=FALSE;
        btnDiscard.Enabled:=TRUE;
        btnDelete.Enabled:=FALSE;
        btnImprimir.Enabled:=FALSE;
        btnVisualizar.Enabled:=FALSE;
        btnAjuda.Enabled:=FALSE;
        btnFechar.Enabled:=FALSE;
      end;
    rdNewForInsert:
      begin
        btnNewForSearch.Enabled:=FALSE;
        btnAppend.Enabled:=FALSE;
        btnSearch.Enabled:=FALSE;
        btnSave.Enabled:=TRUE;
        btnDiscard.Enabled:=TRUE;
        btnDelete.Enabled:=FALSE;
        btnImprimir.Enabled:=FALSE;
        btnVisualizar.Enabled:=FALSE;
        btnAjuda.Enabled:=FALSE;
        btnFechar.Enabled:=FALSE;
      end;
    rdBrowse:
      begin
        btnNewForSearch.Enabled:=TRUE;
        btnAppend.Enabled:=TRUE;
        btnSearch.Enabled:=FALSE;
        btnSave.Enabled:=FALSE;
        btnDiscard.Enabled:=FALSE;
        btnDelete.Enabled:=TRUE;
        btnImprimir.Enabled:=TRUE;
        btnVisualizar.Enabled:=TRUE;
        btnAjuda.Enabled:=TRUE;
        btnFechar.Enabled:=TRUE;
      end;
    rdEdit:
      begin
        btnNewForSearch.Enabled:=FALSE;
        btnAppend.Enabled:=FALSE;
        btnSearch.Enabled:=FALSE;
        btnSave.Enabled:=TRUE;
        btnDiscard.Enabled:=TRUE;
        btnDelete.Enabled:=FALSE;
        btnImprimir.Enabled:=FALSE;
        btnVisualizar.Enabled:=FALSE;
        btnAjuda.Enabled:=FALSE;
        btnFechar.Enabled:=FALSE;
      end;
  end;
end;

procedure TFrmPadrao.CreateFrmRel;
begin
{  Application.CreateForm(TFrmRelPadrao, FrmRelPadrao);
  with FrmRelPadrao do
    begin
      QrpRelPadrao.DataSet  := Dts1.Dataset;
      QRDBText1.DataSet     := Dts1.DataSet;
      QRDBText2.DataSet     := Dts1.DataSet;
      QRDBText3.DataSet     := Dts1.DataSet;
    end;}
end;
procedure TFrmPadrao.BtnSaveClick(Sender: TObject);
var
  j : integer ;
  Txt : TextFile;
  salvar : string;
begin
  Save;
end;

procedure TFrmPadrao.BtnDiscardClick(Sender: TObject);
begin
  Discard;
end;

procedure TFrmPadrao.BtnDeleteClick(Sender: TObject);
var
  j : integer ;
  Txt : TextFile;
  deletar : string;
begin
  deletar := '';
  AssignFile(Txt,'C:\sisven\d.txt');
  append(Txt);
  For j:=0 to Dts1.DataSet.FieldCount - 1 do
    deletar := deletar +';'+ Dts1.DataSet.Fields[j].AsString;
  WriteLn(Txt, deletar);
  CloseFile(Txt);
  Delete;
end;


procedure TFrmPadrao.FormActivate(Sender: TObject);
begin
  PGCManutencao.ActivePage := TBSCadastro;
end;

procedure TFrmPadrao.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  if (Dts1.State = dsInsert) or (Dts1.State = dsEdit) then
    if MessageDlg('Deseja confirmar as alteraes ?',
       mtConfirmation, [mbYes, mbNo], 0) = mrYes then
       Save
    else Discard;
  TBDEDataSet(Dts1.Dataset).Close;
  Action := caFree;
end;

procedure TFrmPadrao.BtnAppendClick(Sender: TObject);
begin
  PGCManutencao.ActivePage := TBSCadastro ;
  NewForInsert;

end;

procedure TFrmPadrao.DBGrid1DblClick(Sender: TObject);
begin
  PGCManutencao.ActivePage := TBSCadastro;
end;

procedure TFrmPadrao.DBGrid1TitleClick(Column: TColumn);
begin
  if (Dts1.Dataset.Active) then
    begin
      Dts1.Dataset.Close;
      if Column = DBGrid1.Columns[0] then
          CmdOrderBy := 'ORDER BY '+Dts1.DataSet.Fields[0].FieldName
      else
          CmdOrderBy := 'ORDER BY '+Dts1.DataSet.Fields[1].FieldName;
      if sQBE <> '' then
         TQuery(Dts1.DataSet).SQL.Text := cmdSelect + ' WHERE ' + sQBE + cmdOrderBy
      else
         TQuery(Dts1.DataSet).SQL.Text := cmdSelect + cmdOrderBy;
      if not TQuery(Dts1.Dataset).Prepared then
        TQuery(Dts1.Dataset).Prepare;
      Dts1.DataSet.Open;
    end;     
end;

end.

